---
operationId: "assignProjectVPCEndpoint"
method: "POST"
path: "/programs/{program_id}/vpc_endpoints/{vpc_endpoint_id}"
tag: "projects"
interfaces: ["api", "sdk", "cli"]
---
> API Reference / Programs / Set VPC endpoint restriction

## POST /programs/{program_id}/vpc_endpoints/{vpc_endpoint_id}

Sets or updates a VPC endpoint restriction for an OptiTech program.
When a VPC endpoint restriction is set, the program only accepts connections
from the specified VPC.
A VPC endpoint can be set as a restriction only after it is assigned to the
parent organization of the OptiTech program.


### Parameters

- `program_id` (string, path, required)
  The OptiTech program ID
- `vpc_endpoint_id` (string, path, required)
  The VPC endpoint ID

### Request body

- `label` (string, required)

### Response (200)

Configured the specified VPC endpoint as a restriction for the specified program.

### Code examples

```bash
curl "https://api.optitech.com/v1/programs/$PROGRAM_ID/vpc_endpoints/$VPC_ENDPOINT_ID" \
  -X POST \
  -H "Authorization: Bearer $OPTITECH_API_KEY"
```

```typescript
import { createOptiTechClient, raw } from '@optitech/sdk';

const optitech = createOptiTechClient({ apiKey: process.env.OPTITECH_API_KEY });
const { data } = await raw.assignProjectVpcEndpoint({
  client: optitech.client,
  path: {
    program_id: process.env.PROGRAM_ID,
    vpc_endpoint_id: process.env.VPC_ENDPOINT_ID
  }
});
```

```bash
# optitechctl
optitech vpc project restrict <vpc_endpoint_id> --project-id <id>
```

### Errors

**default**
General Error.

The request may or may not be safe to retry, depending on the HTTP method, response status code,
and whether a response was received.

- If no response is returned from the API, a network error or timeout likely occurred.
- In some cases, the request may have reached the server and been successfully processed, but the response failed to reach the client. As a result, retrying non-idempotent requests can lead to unintended results.

The following HTTP methods are considered non-idempotent: `POST`, `PATCH`, `DELETE`, and `PUT`. Retrying these methods is generally **not safe**.
The following methods are considered idempotent: `GET`, `HEAD`, and `OPTIONS`. Retrying these methods is **safe** in the event of a network error or timeout.

Any request that returns a `503 Service Unavailable` response is always safe to retry.

Any request that returns a `423 Locked` response is safe to retry. `423 Locked` indicates that the resource is temporarily locked, for example, due to another operation in progress.

- `request_id` (string, optional)
  Unique identifier for the request, useful for debugging.
  You can set this value manually by including an `X-Request-ID` header in the request. If not provided, the value will be generated automatically.
  
- `code` (string, required)
  Default: ``
- `message` (string, required)
  Error message
